program Turn_Q;
{ UJA Version 1.01, 25.04.94 }

uses crt,dos,graph,BGIdriv,BGIFont,drivers;

const dx=32; dy=32; xmax=13; ymax=13;
      ox=32; oy=64;

type feld   =array[0..xmax,0..ymax] of integer;
     imabuff=array[0..4000] of byte;

{ Intuition: ----------------------------------------------------- }

const jam1=0; jam2=1;

type koords =array[0..31] of integer;
     border =record
             x,y,fpen,bpen,drmode,ecken:integer;
             p_ecken                   :^koords;
             p_nextborder              :pointer;
             end;

     image  =record
             x,y         :integer;
             width,height:integer;
             p_data      :^byte;
             p_nextimage :pointer;
             end;

   intuitext=record
             x,y,fpen,bpen,drmode:integer;
             itext               :string;
             p_nexttext          :pointer;
             end;

  boolgadget=record
             id,x,y,width,height,bpen,hibpen:integer;
             p_loborder,p_hiborder          :pointer;
             p_loimage,p_hiimage            :pointer;
             p_lointuitext,p_hiintuitext    :pointer;
             onoff,active                   :boolean;
             p_nextgadget                   :pointer;
             end;

    p_border=^border;
    p_image =^image;
 p_intuitext=^intuitext;
    p_gadget=^boolgadget;





procedure rectfill(x1,y1,x2,y2,c:integer);
var i:integer;
begin  { patch fr BGI-Anweisung BAR }
   Setcolor(c);
   for i:=y1 to y2 do line(x1,i,x2,i);
end;


procedure drawborder(xx,yy:integer; ibord:p_border);
var i,j,x1,x2,y1,y2:integer;
begin
   with ibord^ do begin
     { if drmode=jam2 then begin
         x1:=xx+x; y1:=yy+y;
         rectfill(x1,y1,p_data,bpen);
       end; }
       j:=0;   x1:=p_ecken^[j]+xx;
       inc(j); y1:=p_ecken^[j]+yy;
       setcolor(fpen);
       for i:=2 to ecken do begin
          inc(j); x2:=p_ecken^[j]+xx;
          inc(j); y2:=p_ecken^[j]+yy;
          line(x1,y1,x2,y2);
          x1:=x2;
          y1:=y2;
       end;
       if p_nextborder<>nil then drawborder(xx,yy,p_nextborder);
    end;
end;


procedure DrawImage(xx,yy:integer; ima:p_image);
var x1,y1    :integer;
begin
   with ima^ do begin
      x1:=xx+x;
      y1:=yy+y;
      putimage(x1,y1,ima^.p_data^,normalput);
      if p_nextimage<>nil then drawimage(xx,yy,p_nextimage);
   end;
end;

procedure DrawIntuiText(xx,yy:integer; intext:p_IntuiText);
{ im Moment fixiert auf 8x8-Fonts }
var x1,y1,x2,y2:integer;
    nexttext   :intuitext;
begin
   with intext^ do begin
      x1:=xx+x;
      y1:=yy+y;
      if drmode=jam2 then begin
         x2:=pred(length(itext)*8+x1);
         y2:=y1+7;
         rectfill(x1,y1,x2,y2,bpen);
      end;
      setcolor(fpen);
      outtextxy(x1,y1,itext);
      if p_nexttext<>nil then drawintuitext(xx,yy,p_nexttext);
   end;
end;


procedure DrawGadget(igad:p_gadget);
var i,j,k,x1,x2,x3,x4,y1,y2,y3,y4:integer;
begin
   if igad^.active then with igad^ do begin
      x1:=pred(x+width);
      y1:=y+pred(height);
      if onoff then begin
         if hibpen>-1 then rectfill(x,y,x1,y1,hibpen);
         if p_hiimage<>nil then DrawImage(x,y,p_hiimage);
         if p_hiborder<>nil then DrawBorder(x,y,p_hiborder);
         if p_hiintuitext<>nil then DrawIntuiText(x,y,p_hiintuitext);
      end else begin
         if bpen>-1 then rectfill(x,y,x1,y1,bpen);
         if p_loimage<>nil then DrawImage(x,y,p_loimage);
         if p_loborder<>nil then DrawBorder(x,y,p_loborder);
         if p_lointuitext<>nil then DrawIntuiText(x,y,p_lointuitext);
      end;
   end;
{   if igad^.p_nextgadget<>nil then drawgadget(igad^.p_nextgad);
   end;  }
end;




          




{ ##### Uff, soweit so gut, Amigos! ################################## }
{ -------------------------------------------------------------------- }



var igad                       :array[1..8] of boolgadget;
    itext1,itext2              :array[1..8] of intuitext;
    ibord1,ibord2,ibord3,ibord4:array[1..8] of border;
    ima                        :array[0..7] of image;
    p_hilf                     :pointer;
    ibuff:imabuff;
    xy1,xy2,xy3,xy4:koords;
    mh             :TEvent;

    spalten,zeilen,drehen,mx,my,g,i,j:integer;
    dsec,dsec1,dsec2                 :longint;

    ok,fertig,ende,vonvorne,weiter   :boolean;
    f,fo :feld;
    oox,ooy:integer;

    s1,s2:string;


{ Screen- und Musekram ------------------- }

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

procedure register;
begin
  { Register all the drivers }
  if RegisterBGIdriver(@CGADriverProc) < 0 then
    Abort('CGA');
  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA/VGA');
  if RegisterBGIdriver(@HercDriverProc) < 0 then
    Abort('Herc');
  if RegisterBGIdriver(@ATTDriverProc) < 0 then
    Abort('AT&T');
  if RegisterBGIdriver(@PC3270DriverProc) < 0 then
    Abort('PC 3270');
  { Register all the fonts }
  if RegisterBGIfont(@GothicFontProc) < 0 then
    Abort('Gothic');
  if RegisterBGIfont(@SansSerifFontProc) < 0 then
    Abort('SansSerif');
  if RegisterBGIfont(@SmallFontProc) < 0 then
    Abort('Small');
  if RegisterBGIfont(@TriplexFontProc) < 0 then
    Abort('Triplex');
end;



procedure initscr(var ok:boolean);
var i,j,k,graphdriver,graphmode,errcode:integer;
    r,g,b                          :word;
begin
   register;
   graphdriver:=detect;
   initgraph(graphdriver,graphmode,'');
   ok:=(graphresult=0) and (graphdriver=9);

   if ok then begin
      SetRGBPalette(0,0,0,0);
      SetRGBPalette(1,63,63,58);
      SetRGBPalette(2,32,32,25);
      SetRGBPalette(3,48,48,48);
      SetRGBPalette(4,32,13,0);
      SetRGBPalette(5,38,20,10);
      SetRGBPalette(6,48,23,29);
      SetRGBPalette(7,54,29,38);
      SetRGBPalette(8,58,38,48);
      SetRGBPalette(9,63,48,61);
      SetRGBPalette(10,23,23,32);
      SetRGBPalette(11,25,25,38);
      SetRGBPalette(12,29,29,45);
      SetRGBPalette(13,32,35,52);
      SetRGBPalette(14,35,42,58);
      SetRGBPalette(15,38,52,63);
      for i:=0 to 15 do setpalette(i,i);
   end;
end;




procedure initmouse;
begin
screenwidth:=getmaxx;
screenheight:=getmaxy;
startupmode:=screenmode;
initevents;
showmouse;
end;



procedure getsecs(var s:longint);
var h,min,sec,jiffy:word;
begin
gettime(h,min,sec,jiffy);
s:=60*(60*h+min)+sec;
end;



procedure initimages;
const hex='0123456789ABCDEF ';
var t1,t2,t3,t4,t5,t6,t7:string;
    i,j,k,c             :integer;
    size                :longint;
    bufptr              :integer;



   procedure getthem(var ima:image; var size:longint);
   var i,j,k,c:integer;
   begin
   with ima do begin
   k:=1;
   for i:=1 to length(t1) do begin
      c:=pos(t1[i],hex)-1;
      putpixel(i,k,c);
   end;
   inc(k);
   for i:=1 to length(t2) do begin
      c:=pos(t2[i],hex)-1;
      putpixel(i,k,c);
   end;
   inc(k);
   for i:=1 to length(t3) do begin
      c:=pos(t3[i],hex)-1;
      putpixel(i,k,c);
   end;
   for j:=1 to 2 do begin
      inc(k);
      for i:=1 to length(t4) do begin
         c:=pos(t4[i],hex)-1;
         putpixel(i,k,c);
      end;
   end;
   for j:=1 to 11 do begin
      inc(k);
      for i:=1 to length(t5) do begin
         c:=pos(t5[i],hex)-1;
         putpixel(i,k,c);
      end;
      inc(k);
      for i:=1 to length(t6) do begin
         c:=pos(t6[i],hex)-1;
         putpixel(i,k,c);
      end;
   end;
   for j:=1 to 2 do begin
      inc(k);
      for i:=1 to length(t4) do begin
         c:=pos(t4[i],hex)-1;
         putpixel(i,k,c);
      end;
   end;
   inc(k);
   for i:=1 to length(t7) do begin
      c:=pos(t7[i],hex)-1;
      putpixel(i,k,c);
   end;
   inc(k);
   for i:=1 to length(t1) do begin
      c:=pos(t1[i],hex)-1;
      putpixel(i,k,c);
   end;
   p_data:=addr(ibuff[bufptr]);
   p_nextimage:=nil;
   x:=0;
   y:=0;
   GetImage(1,1,width+1,height+1,p_data^);
   size:=ImageSize(2*(x+1),2*(y+1),2*(x+dx)+1,2*(y+dy)+1);
   end;
   end;


begin
bufptr:=0;
with ima[1] do begin
   width:=32;
   height:=32;
   t1:='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA';
   t2:='ADDDDDDDDDDDDDDDDDDDDDDDDDDDDDDA';
   t3:='AD1111111111111111111111111111DA';
   t4:='AD1DDDDDDDDDDDDDDDDDDDDDDDDDD0DA';
   t5:='AD1DDAAABBBBCCCCDDDDEEEE999DD0DA';
   t6:='AD1DDAABABBCBCCDCDDEDEE9E99DD0DA';
   t7:='AD0000000000000000000000000000DA';
end;
getthem(ima[1],size);
bufptr:=bufptr+size;
with ima[2] do begin
   width:=32;
   height:=32;
   t1:='44444444444444444444444444444444';
   t2:='47777777777777777777777777777774';
   t3:='47111111111111111111111111111174';
   t4:='47177777777777777777777777777074';
   t5:='47177AAA555566667777888899977074';
   t6:='47177AA5A55656676778788989977074';
   t7:='47000000000000000000000000000074';
end;
getthem(ima[2],size);
end;

procedure screenzeichnen;
{ intuition-kram }
var i,x,y,z:integer; t:string;
begin
   { --- Background und Shadows: --- }
   rectfill(1,1,639,479,2);
   rectfill(8,8,639,31,0);
   rectfill(452,oy+dy+4,596,oy+dy+27,0);
   rectfill(452,oy+dy+52,596,oy+dy+75,0);
   rectfill(452,oy+dy+100,596,oy+dy+123,0);
   rectfill(452,oy+dy+148,596,oy+dy+171,0);
   rectfill(452,oy+dy+196,596,oy+dy+219,0);
   rectfill(452,oy+dy+244,596,oy+dy+267,0);

   { Header: --- }
   rectfill(4,4,635,27,3);
   setcolor(1); line(5,5,634,5);   line(5,5,5,26);
   setcolor(0); line(5,26,634,26); line(634,5,634,26);
   outtextxy(120,12,'U J A s    T u r n    i t                  TP6 V1.01 4/94');

   { --- Bool-Gadgets : ------------ }
   with itext1[1] do begin
      p_nexttext:=nil;
      x:=12;
      y:=8;
      drmode:=jam2;
      fpen:=0;
      bpen:=3;
   end;

   xy1[0]:=1; xy1[1]:=22; xy1[2]:=1;   xy1[3]:=1;  xy1[4]:=142; xy1[5]:=1;
   xy2[0]:=1; xy2[1]:=22; xy2[2]:=142; xy2[3]:=22; xy2[4]:=142; xy2[5]:=1;
   with ibord1[1] do begin
      x:=0; y:=0; fpen:=1; bpen:=3; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy1[0]);
      p_nextborder:=addr(ibord2[1]);
   end;
   with ibord2[1] do begin
      x:=0; y:=0; fpen:=0; bpen:=3; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy2[0]);
      p_nextborder:=nil;
   end;
   for i:=2 to 6 do begin
      ibord1[i]:=ibord1[1];
      ibord2[i]:=ibord2[1];
      itext1[i]:=itext1[1];
   end;
   itext1[1].itext:='      Neu';
   itext1[2].itext:='     Ende';

   str(zeilen:2,t);   itext1[3].itext:='-  Zeilen:'+t+' +';
   str(spalten:2,t);  itext1[4].itext:='- Spalten:'+t+' +';
   str(drehen:2,t);   itext1[5].itext:='-  Turns: '+t+' +';
   itext1[6].itext:='  Zeit: xxxx s';

   ibord3:=ibord1; ibord4:=ibord2;
   itext2:=itext1;
   for i:=1 to 6 do begin
      ibord3[i].p_nextborder:=addr(ibord4[i]);
      ibord3[i].fpen:=0;
      ibord4[i].fpen:=1;
      itext2[i].fpen:=1;
      itext2[i].bpen:=2;
   end;


   for i:=1 to 6 do with igad[i] do begin
      x:=448;
      y:=oy+dy+pred(i)*48;
      width:=144;
      height:=24;
      bpen:=itext1[i].bpen;
      hibpen:=itext2[i].bpen;
      id:=i;
      p_nextgadget:=addr(igad[i+1]);
      p_loborder:=addr(ibord1[i]);
      p_hiborder:=addr(ibord3[i]);
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=addr(itext2[i]);
      active:=true;
      onoff:=false;
      p_hilf:=addr(igad[i]);
      drawgadget(p_hilf);
   end;
   i:=7; with igad[i] do begin
      x:=ox;
      y:=oy;
      width:=pred(xmax)*dx;
      height:=pred(ymax)*dy;
      bpen:=1;
      hibpen:=-1;
      id:=i;
      p_nextgadget:=nil;
      p_loborder:=nil;
      p_hiborder:=nil;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=nil;
      active:=true;
      onoff:=false;
   end;
end;

{ ------------------------------------------------------------ }

procedure feldzeichnen(xx,yy:integer);
var i,x,y,x1,y1:integer;
begin
   { Feld zeichnen }
   x:=ox+dx div 4;
   y:=oy+dy div 4;
   x1:=x+pred(xmax)*dx;
   y1:=y+pred(ymax)*dy;
   rectfill(x,y,x1,y1,0);
   x1:=ox+dx*pred(xmax);
   y1:=oy+dy*pred(ymax);
   rectfill(ox,oy,x1,y1,4);
   x1:=oox;
   for x:=1 to xx do begin
      y1:=ooy;
      for y:=1 to yy do begin
         p_hilf:=addr(ima[f[x,y]]);
         DrawImage(x1,y1,p_hilf);
         y1:=y1+dy;
      end;
      x1:=x1+dx;
   end;
end;


procedure feldinit;
var i,j:integer;
begin for i:=0 to xmax do for j:=0 to ymax do f[i,j]:=1; end;


procedure turnit(x,y:integer);
var i,j,x1,x2,y1,y2:integer;
begin
   x1:=pred(x); if x1<1 then x1:=1;
   x2:=succ(x); if x2>spalten then x2:=spalten;
   y1:=pred(y); if y1<1 then y1:=1;
   y2:=succ(y); if y2>zeilen then y2:=zeilen;
   for i:=x1 to x2 do for j:=y1 to y2 do begin
      if f[i,j]=1 then f[i,j]:=2 else f[i,j]:=1;
      p_hilf:=addr(ima[f[i,j]]);
      DrawImage(oox+dx*pred(i),ooy+pred(j)*dy,p_hilf);
   end;
end;

procedure mischen(turns:integer);
var i,j,k:integer;
begin
randomize;
for k:=1 to turns do begin
   i:=succ(random(1000) mod spalten);
   j:=succ(random(1000) mod zeilen);
   turnit(i,j);
end;
end;



procedure ausfuehren(var fertig:boolean);
var x,y,i,j:integer;
    ok     :boolean;
begin
   x:=succ((mx-oox) div dx);
   y:=succ((my-ooy) div dy);
   ok:=(x>0) and (x<=spalten);
   ok:=ok and (y>0) and (y<=zeilen);
   if ok then begin
      hidemouse;
      turnit(x,y);
      showmouse;
      fertig:=true;
      for i:=1 to spalten do for j:=1 to zeilen do
      if f[i,j]<>f[1,1] then fertig:=false;
   end;
end;


procedure checkgadgets(startgad:p_gadget; mx,my:integer; var g:integer);
var ok:boolean;
begin
   g:=-1;
   with startgad^ do begin   { Integer-Sets sind noch uerst buggy! }
       ok:=(mx>x) and (mx<(x+width));
       ok:=ok and (my>y) and (my<(y+height));
       if ok then g:=id else if p_nextgadget<>nil then checkgadgets(p_nextgadget,mx,my,g);
   end;
   { patch as patch can! }
end;



procedure fanfare;
var i,j,x,y,z:integer;
begin
hidemouse;
for i:=1 to 4*zeilen*spalten do begin
   x:=random(dx*pred(spalten))+oox;
   y:=random(dy*pred(zeilen))+ooy;
   if odd(random(1000)) then p_hilf:=addr(ima[1]) else p_hilf:=addr(ima[2]);
   drawimage(x,y,p_hilf);
end;
showmouse;
end;




procedure updatsecs(s:longint);
var t:string;
begin
   str(s:4,t);
   itext1[6].itext:='  Zeit: '+t+' s';
   p_hilf:=addr(igad[6]);
   hidemouse;
   drawgadget(p_hilf);
   showmouse;
end;




procedure mausauswerten;
begin
   getmouseevent(mh);
   if mh.what=evmouseup then begin
      mx:=mh.where.x * 8;
      my:=mh.where.y * 8;
      g:=-1;
      p_hilf:=addr(igad[1]);
      checkgadgets(p_hilf,mx,my,j);
      if j>-1 then begin
         g:=j;
         p_hilf:=addr(igad[g])
      end;
      case g of
      1: fertig:=true;
      2: ende:=true;
      3: begin
            my:=igad[g].x+igad[g].width div 2;
            if mx<my then if zeilen>6 then dec(zeilen);
            if mx>my then if zeilen<pred(xmax) then inc(zeilen);
            str(zeilen:2,s1);
            itext1[g].itext:='-  Zeilen:'+s1+'  +';
            itext2[g].itext:=itext1[g].itext;
            hidemouse;
            drawgadget(p_hilf);
            showmouse;
            fertig:=true;
         end;
      4: begin
            my:=igad[g].x+igad[g].width div 2;
            if mx<my then if spalten>6 then dec(spalten);
            if mx>my then if spalten<pred(ymax) then inc(spalten);
            str(spalten:2,s1);
            itext1[g].itext:='- Spalten:'+s1+'  +';
            itext2[g].itext:=itext1[g].itext;
             hidemouse;
            drawgadget(p_hilf);
            showmouse;
            fertig:=true;
          end;
      5: begin
            my:=igad[g].x+igad[g].width div 2;
            if mx<my then if drehen>5  then dec(drehen);
            if mx>my then if drehen<24 then inc(drehen);
            str(drehen:3,s1);
            itext1[g].itext:='-  Turns:'+s1+'  +';
            itext2[g].itext:=itext1[g].itext;
             hidemouse;
            drawgadget(p_hilf);
            showmouse;
            fertig:=true;
         end;
      else ;
      end;
   end;
end;



begin
   zeilen:=12;
   spalten:=12;
   drehen:=12;
g:=paramcount;
case g of
1: begin
      val(paramstr(1),j,i);
      if i=0 then drehen:=j;
   end;
2: begin
      val(paramstr(1),j,i);
      if i=0 then zeilen:=j;
      val(paramstr(2),j,i);
      if i=0 then spalten:=j;
   end;
3: begin
      val(paramstr(1),j,i);
      if i=0 then zeilen:=j;
      val(paramstr(2),j,i);
      if i=0 then spalten:=j;
      val(paramstr(3),j,i);
      if i=0 then drehen:=j;
   end;
   else ;
   end;


initscr(ok);
if ok then begin
   initimages;
   screenzeichnen;

   initmouse;
   ende:=false;
   while not ende do begin
      hidemouse;
      feldinit;
      oox:=ox+(pred(xmax)-spalten)*(dx div 2);
      ooy:=oy+(pred(ymax)-zeilen)*(dy div 2);
      feldzeichnen(spalten,zeilen);
      mischen(drehen);
      fertig:=false;
      getsecs(dsec1);
      dsec2:=dsec1;
      dsec:=dsec2-dsec1;
      updatsecs(dsec);
      showmouse;
      while not (fertig or ende) do begin
         getsecs(dsec2);
         if dsec<(dsec2-dsec1) then begin
            dsec:=dsec2-dsec1;
            updatsecs(dsec);
         end;

         mausauswerten;
         if g=7 then begin
            g:=-1;
            ausfuehren(fertig);
            if fertig then begin
               fanfare;
               repeat
               delay(50);
               weiter:=keypressed;
               if weiter then ende:=(readkey=#27) else begin
                  mausauswerten;
                  weiter:=g>-1;
               end;
            until weiter;
         end;
      end;
     if keypressed then if readkey=#27 then ende:=true;
   end;
end;
end;
textmode(3);


end.

